require 'rubygems'
require 'active_record'

ActiveRecord::Base.establish_connection :adapter => "sqlite3",
                                        :database => "steamdb.sqlite3" 
                  
ActiveRecord::Base.connection.create_table :developers do |t|  
  t.string   :name
  t.string   :country
end

ActiveRecord::Base.connection.create_table :games do |t|
  t.string :name
  t.text :description
  t.boolean :is_released
  t.references :developer, foreign_key: true
end  

ActiveRecord::Base.connection.create_table :prices do |t|
  t.integer :price_us
  t.integer :price_br
  t.integer :price_ru
  t.references :game, foreign_key: true 
end

ActiveRecord::Base.connection.create_table :categories do |t|
  t.string :name
  t.text :description
end

ActiveRecord::Base.connection.create_table :category_games, id: false do |t|
  t.references :category
  t.references :game
end
